<?php
define('ROJ_GROUP_PATH', '{groupPath}');
define('ROJ_GROUP_SHARE', '{groupShare}');
define('ROJ_USER_SELF', '{userSelf}');
define('ROJ_USER_SHARE', '{userShare}');
define('ROJ_USER_RECYCLE', '{userRecycle}');
define('ROJ_USER_FAV', '{userFav}');
define('ROJ_GROUP_ROOT_SELF', '{treeGroupSelf}');
define('ROJ_GROUP_ROOT_ALL', '{treeGroupAll}');

function _make_file_proxy($file){
	$config = $GLOBALS['config'];
	if (!file_exists($file)) {
		return '';
	}
	$safepassword = $config['settingSystem']['systemPassword'];
	$file_id = Mcrypt::encode($file, $safepassword, $config['settings']['downloadUrlTime']);
	$endoded_name = rawurlencode(iconv_app(get_path_this($file)));
	$system_url = APP_HOST.'index.php?';
	if (isset($config['settings']['paramRewrite']) && $config['settings']['paramRewrite'] == true) {
		$system_url = APP_HOST.'index.php/';
	}
	return $system_url.'user/publicLink&fid='.$file_id.'&file_name=/'.$endoded_name;
}

function _DIR_CLEAR($filepath){
	$filepath = str_replace('\\', '/', trim($filepath ?? ''));
	$filepath = preg_replace('/\/+/', '/', $filepath);
	$xzv_15 = $filepath;
	if (isset($GLOBALS['isRoot']) && $GLOBALS['isRoot']) {
		return $filepath;
	}
	$xzv_47 = '/../';
	while (strstr($filepath, $xzv_47)) {
		$filepath = str_replace($xzv_47, '/', $filepath);
	}
	if (substr($filepath, 0, 3) == '../') {
		$filepath = substr($filepath, 3);
	}
	if (substr($filepath, strlen($filepath) - 3) == '/..') {
		$filepath = substr($filepath, 0, strlen($filepath) - 3);
	}
	if ($filepath == '..') { // 跳出目录的安全问题修正
		$filepath = '';
	}
	$filepath = preg_replace('/\/+/', '/', $filepath);
	return $filepath;
}

function _DIR($in)
{
	$filename = _DIR_CLEAR($in);
	$filename = iconv_system($filename);
	$RojpathArr = array(
		ROJ_GROUP_PATH,
		ROJ_GROUP_SHARE,
		ROJ_USER_SELF,
		ROJ_GROUP_ROOT_SELF,
		ROJ_GROUP_ROOT_ALL,
		ROJ_USER_SHARE,
		ROJ_USER_RECYCLE,
		ROJ_USER_FAV,
	);
	if(!defined('HOME')) {
		define('HOME', user_home_path(systemMember::getInfo($GLOBALS['rojPathId'])));
	}
	$GLOBALS['rojPathType'] = '';
	$GLOBALS['rojPathPre'] = HOME;
	$GLOBALS['rojPathId'] = '';
	unset($GLOBALS['rojPathIdShare']);
	foreach ($RojpathArr as $path) {
		if (substr($filename, 0, strlen($path)) == $path) {
			$GLOBALS['rojPathType'] = $path;
			$patharr = explode('/', $filename);//路径
			$firstpath = $patharr[0];
			unset($patharr[0]);
			$realpath = implode('/', $patharr); 
			$diskname = explode(':', $firstpath); //卷标
			if (count($diskname) > 1) {
				$GLOBALS['rojPathId'] = trim($diskname[1]);
			}
			else {
				$GLOBALS['rojPathId'] = '';
			}
			break;
		}
	}
	switch ($GLOBALS['rojPathType']) {
	case '':
		$filename = iconv_system(HOME).$filename;
		break;
	case ROJ_USER_RECYCLE:
		$GLOBALS['rojPathPre'] = trim(USER_RECYCLE, '/');
		$GLOBALS['rojPathId'] = '';
		return iconv_system(USER_RECYCLE).'/'.str_replace(ROJ_USER_RECYCLE,
			'', $filename);
	case ROJ_USER_SELF:
		$GLOBALS['rojPathPre'] = trim(HOME_PATH, '/');
		$GLOBALS['rojPathId'] = '';
		return iconv_system(HOME_PATH).'/'.str_replace(ROJ_USER_SELF, '',
			$filename);
	case ROJ_USER_FAV:
		$GLOBALS['rojPathPre'] = trim(ROJ_USER_FAV, '/');
		$GLOBALS['rojPathId'] = '';
		return ROJ_USER_FAV;
	case ROJ_GROUP_ROOT_SELF:
		$GLOBALS['rojPathPre'] = trim(ROJ_GROUP_ROOT_SELF, '/');
		$GLOBALS['rojPathId'] = '';
		return ROJ_GROUP_ROOT_SELF;
	case ROJ_GROUP_ROOT_ALL:
		$GLOBALS['rojPathPre'] = trim(ROJ_GROUP_ROOT_ALL, '/');
		$GLOBALS['rojPathId'] = '';
		return ROJ_GROUP_ROOT_ALL;
	case ROJ_GROUP_PATH:
		$pathid = systemGroup::getInfo($GLOBALS['rojPathId']);
		if (!$GLOBALS['rojPathId'] || !$pathid)return false;
		owner_group_check($GLOBALS['rojPathId']);
		$GLOBALS['rojPathPre'] = group_home_path($pathid);
		$filename = iconv_system($GLOBALS['rojPathPre']).$realpath;
		break;
	case ROJ_GROUP_SHARE:
		$pathid = systemGroup::getInfo($GLOBALS['rojPathId']);
		if (!$GLOBALS['rojPathId'] || !$pathid)return false;
		owner_group_check($GLOBALS['rojPathId']);
		$GLOBALS['rojPathPre'] = group_home_path($pathid).'share/';
		$filename = iconv_system($GLOBALS['rojPathPre']).$realpath;
		break;
	case ROJ_USER_SHARE:
		$pathid = systemMember::getInfo($GLOBALS['rojPathId']);
		if (!$GLOBALS['rojPathId'] || !$pathid)return false;
		if ($GLOBALS['rojPathId'] != $_SESSION['rojUser']['userID']){
			$xzv_50 = $GLOBALS['config']['pathRoleGroupDefault']['1']['actions'];
			path_role_check($xzv_50);
		}
		$GLOBALS['rojPathPre'] = '';
		$GLOBALS['rojPathIdShare'] = $in;
		if ($realpath == ''){
			return $filename;
		}
		else {
			$newpath = explode('/', $realpath);
			$newpath[0] = iconv_app($newpath[0]);
			$filepath0 = systemMember::userShareGet($GLOBALS['rojPathId'], $newpath[0]);
			$GLOBALS['rojShareInfo'] = $filepath0;
			$GLOBALS['rojPathIdShare'] = ROJ_USER_SHARE.':'.$GLOBALS['rojPathId']
				. '/'.$newpath[0].'/';
			unset($newpath[0]);
			if (!$filepath0)return false;
			$filename_n = rtrim($filepath0['path'], '/').'/'.iconv_app(implode('/',
				$newpath));
			if ($pathid['role'] != '1'){
				$homepath = user_home_path($pathid);
				$GLOBALS['rojPathPre'] = $homepath.rtrim($filepath0['path'], '/')
					. '/';
				$filename = $homepath.$filename_n;
			}
			else {
				$GLOBALS['rojPathPre'] = $filepath0['path'];
				$filename = $filename_n;
			}
			if ($filepath0['type'] == 'file'){
				$GLOBALS['rojPathIdShare'] = rtrim($GLOBALS['rojPathIdShare'],
					'/');
				$GLOBALS['rojPathPre'] = rtrim($GLOBALS['rojPathPre'], '/');
			}
			$filename = iconv_system($filename);
		}
		break;
	default:
		break;
	}
	if ($filename != '/') {
		$filename = rtrim($filename, '/');
		if (is_dir($filename)) $filename = $filename.'/';
	}
	return $filename;
}

function _DIR_OUT($xzv_10)
{
	if (is_array($xzv_10)) {
		foreach ($xzv_10['fileList'] as $xzv_22 => &$filepath2) {
			$filepath2['path'] = preClear($filepath2['path']);
		}
		foreach ($xzv_10['folderList'] as $xzv_22 => &$filepath2) {
			$filepath2['path'] = preClear(rtrim($filepath2['path'], '/').'/');
		}
	}
	else {
		$xzv_10 = preClear($xzv_10);
	}
	return $xzv_10;
}

function preClear($xzv_28)
{
	$filepath1 = $GLOBALS['rojPathType'];
	$xzv_18 = rtrim($GLOBALS['rojPathPre'], '/');
	$xzv_17 = array(
		ROJ_USER_FAV,
		ROJ_GROUP_ROOT_SELF,
		ROJ_GROUP_ROOT_ALL
	);
	if (isset($GLOBALS['rojPathType']) && in_array($GLOBALS['rojPathType'],
		$xzv_17)) {
		return $xzv_28;
	}
	if (ST == 'share') {
		return str_replace($xzv_18 ?? '', '', $xzv_28 ?? '');
	}
	if ($GLOBALS['rojPathId'] != '') {
		$filepath1 .= ':'.$GLOBALS['rojPathId'].'/';
	}
	if (isset($GLOBALS['rojPathIdShare'])) {
		$filepath1 = $GLOBALS['rojPathIdShare'];
	}
	$xzv_21 = $filepath1.str_replace($xzv_18 ?? '', '', $xzv_28 ?? '');
	$xzv_21 = str_replace('//', '/', $xzv_21 ?? '');
	return $xzv_21;
}

function check_file_writable_user($xzv_52)
{
	if (!isset($GLOBALS['rojPathType'])) {
		_DIR($xzv_52);
	}
	$xzv_53 = 'editor.fileSave';
	if ($GLOBALS['isRoot']) return @is_writable($xzv_52);
	if ($GLOBALS['auth'][$xzv_53] != '1') {
		return false;
	}
	if ($GLOBALS['rojPathType'] == ROJ_GROUP_PATH && is_array($GLOBALS['rojPathRoleGroupAuth'])
		&& $GLOBALS['rojPathRoleGroupAuth'][$xzv_53] == '1') {
		return true;
	}
	if ($GLOBALS['rojPathType'] == '' || $GLOBALS['rojPathType'] == ROJ_USER_SELF) {
		return true;
	}
	return false;
}

function space_size_use_check(){
	if ($GLOBALS['isRoot'] == 1) return;
	if (isset($GLOBALS['rojBeforePathId']) && isset($GLOBALS['rojPathId'])
		&& $GLOBALS['rojBeforePathId'] == $GLOBALS['rojPathId']) {
		return;
	}
	if ($GLOBALS['rojPathType'] == ROJ_GROUP_SHARE || $GLOBALS['rojPathType'] == ROJ_GROUP_PATH) {
		systemGroup::spaceCheck($GLOBALS['rojPathId']);
	}
	else {
		if (ST == 'share') {
			$xzv_56 = $GLOBALS['in']['user'];
		}
		else {
			$xzv_56 = $_SESSION['rojUser']['userID'];
		}
		systemMember::spaceCheck($xzv_56);
	}
}

function spaceSizeChange($filepath4, $filepath3 = true, $xzv_48 = false, $filepath6 = false)
{
	if ($xzv_48 === false) {
		$xzv_48 = $GLOBALS['rojPathType'];
		$filepath6 = $GLOBALS['rojPathId'];
	}
	$filepath3 = $filepath3 ? 1 : -1;
	if (is_file($filepath4)) {
		$filepath7 = get_filesize($filepath4);
	}
	else if (is_dir($filepath4)) {
		$xzv_5 = _path_info_more($filepath4);
		$filepath7 = $xzv_5['size'];
	}
	else {
		return;
	}
	if ($xzv_48 == ROJ_GROUP_SHARE || $xzv_48 == ROJ_GROUP_PATH) {
		systemGroup::spaceChange($filepath6, $filepath7 * $filepath3);
	}
	else {
		if (ST == 'share') {
			$xzv_54 = $GLOBALS['in']['user'];
		}
		else {
			$xzv_54 = $_SESSION['rojUser']['userID'];
		}
		systemMember::spaceChange($xzv_54, $filepath7 * $filepath3);
	}
}

function spaceSizeChange_move($xzv_57)
{
	if (isset($GLOBALS['rojBeforePathId']) && isset($GLOBALS['rojPathId'])) {
		if ($GLOBALS['rojBeforePathId'] == $GLOBALS['rojPathId']) {
			return;
		}
		else {
			spaceSizeChange($xzv_57);
			spaceSizeChange($xzv_57, false, $GLOBALS['beforePathType'], $GLOBALS['rojBeforePathId']);
		}
	}
	else {
		spaceSizeChange($xzv_57);
	}
}

function space_size_use_reset()
{
	$xzv_9 = isset($GLOBALS['rojPathType']) ? $GLOBALS['rojPathType'] : '';
	$xzv_8 = isset($GLOBALS['rojPathId']) ? $GLOBALS['rojPathId'] : '';
	if ($xzv_9 == ROJ_GROUP_SHARE || $xzv_9 == ROJ_GROUP_PATH) {
		systemGroup::spaceChange($xzv_8);
	}
	else {
		$xzv_25 = $_SESSION['rojUser']['userID'];
		systemMember::spaceChange($xzv_25);
	}
}

function group_home_path($group_name){
	$path = GROUP_PATH.$group_name['path'].'/home/';
	if (isset($group_name['homePath']) && file_exists(iconv_system($group_name['homePath']))) {
		$path = $group_name['homePath'];
	}
	return $path;
}

function path_role_check($role)
{
	if ($GLOBALS['isRoot'] || (isset($GLOBALS['rojPathAuthCheck']) && $GLOBALS['rojPathAuthCheck'] === true)) {
		return;
	}
	$permission = role_permission_arr($role);
	$GLOBALS['rojPathRoleGroupAuth'] = $permission;
	if (!isset($permission[ST.'.'.ACT]) && ST != 'share') {
		show_json(LNG('no_permission_action'), false);
	}
}

function role_permission_arr($permission)
{
	$tmp = array();
	$RolesArr = $GLOBALS['config']['pathRoleDefine'];
	foreach ($permission as $key => $val) {
		if (!$val) continue;
		$Pid = explode(':', $key);
		if (count($Pid) == 2 && is_array($RolesArr[$Pid[0]]) && is_array($RolesArr[$Pid[0]][$Pid[1]])) {
			$tmp = array_merge($tmp, $RolesArr[$Pid[0]][$Pid[1]]);
		}
	}
	$result = array();
	foreach ($tmp as $val) {
		$result[$val] = '1';
	}
	return $result;
}

function user_home_path($user_name){
	$path = USER_PATH.$user_name['path'].'/home/';
	if (isset($user_name['homePath']) && file_exists(iconv_system($user_name['homePath']))) {
		$path = $user_name['homePath'];
	}
	return $path;
}

function owner_group_check($group)
{
	if (!$group) show_json(LNG('group_not_exist').$group, false);
	if ($GLOBALS['isRoot'] || (isset($GLOBALS['rojPathAuthCheck']) && $GLOBALS['rojPathAuthCheck'] === true)) {
		return;
	}
	$premisson = systemMember::userAuthGroup($group);
	if ($premisson == false) {
		if ($GLOBALS['rojPathType'] == ROJ_GROUP_PATH) {
			show_json(LNG('no_permission_group'), false);
		}
		else if ($GLOBALS['rojPathType'] == ROJ_GROUP_SHARE) {
			$isowner = $GLOBALS['config']['pathRoleGroupDefault']['1'];
		}
	}
	else {
		$isowner = $GLOBALS['config']['pathRoleGroup'][$premisson];
	}
	path_role_check($isowner['actions']);
}
