<?php if(!defined('IN_SYSTEM')){die("Access Denied!");} ?><?php
/*
* @product RojExplorer
* @author Luojie
* @copyright rojcms team 2017.
*/

/**
 * 控制器抽象类
 */
abstract class Controller {
	public $in;
	public $config;	// 全局配置
	public $tpl;	// 模板目录
	public $values;	// 模板变量

	/**
	 * 构造函数
	 */
	function __construct(){
		global $in,$config;
		$this ->config = &$config;
		$this ->in = &$in;	
		$this ->values['config'] = &$config;
		$this ->values['in'] = &$in;
		$this ->tpl = TEMPLATE.get_class($this).'/';
	} 

	/**
	 * 加载模型
	 * @param string $class 
	 */
	public function loadModel($class){
		$args = func_get_args();
		$this -> $class = call_user_func_array('init_model', $args);
		return $this -> $class;
	} 

	/**
	 * 加载类库文件
	 * @param string $class 
	 */
	public function loadClass($class){
		if (1 === func_num_args()) {
			$this -> $class = new $class;
		} else {
			$reflectionObj = new ReflectionClass($class);
			$args = func_get_args();
			array_shift($args);
			$this -> $class = $reflectionObj -> newInstanceArgs($args);
		}
		return $this -> $class;
	}

	/**
	 * 显示模板
	 * 
	 * TODO smarty
	 * @param
	 */
	protected function assign($key,$value){
		$this->values[$key] = $value;
	} 
	/**
	 * 显示模板
	 * @param
	 */
	protected function display($tplFile, $rep = true){
		ob_end_clean();
		extract($this->values);
		$fake_path = $this->tpl;
		if(!$fake_path) $fake_path = TEMPLATE;
		$fake_path = $fake_path.":*";
		$fake_path = str_replace("/:*","",$fake_path);
		$fake_path = str_replace(TEMPLATE,"",$fake_path);
		$engine = new MyTemplateEngine();
		$template = $engine->fetch_template($tplFile,$fake_path,$rep);
		include($template);
		if(defined('SHOW_TRACES')){
			$fake_path = TEMPLATE.'develop/';
			$fake_path = $fake_path.":*";
			$fake_path = str_replace("/:*","",$fake_path);
			$fake_path = str_replace(TEMPLATE,"",$fake_path);
			$tplFile = 'trace.html';
			$template = $engine->fetch_template($tplFile,$fake_path,$rep);
			$traces = develop::init();
			include($template);
		}
	} 
} 
