<?php
$execTime=mtime();
IF(!DEFINED('IN_SYSTEM')) DIE("Access Denied");

class MyTemplateEngine {

    public $replacecode = array('search' => array(), 'replace' => array());
    public $file = '';
    public $default_language = 'zh-CN';
    private $includeTemplate = array();//记录模版更新时间和路径
    private $tplname = '';//模板名称

    function __call($function_name, $args) {
        echo "你所调用的函数：$function_name(参数：<br />";
        var_dump($args);
        echo ")不存在！";
    }
    //获取模板语言
    public function check_language(){
        $this->default_language = I18n::GetType();
    }
    public function fetch_template($tplfile, $tpldir, $needreplace){
        $this->tplname = $tplfile;
        $tplfile = $this->parse_tplfile($tplfile,$tpldir);
        $this->check_language();

        $cachefile = TEMP_DIR.$tpldir.'_'.str_replace('.php', '', $this->tplname).'_'.$this->default_language.'.tpl.php';
        //$cachefile = str_replace("_/","_",$cachefile);
        //$cachefile = str_replace("__","_",$cachefile);
        $this->includeTemplate[$tplfile] = filemtime($tplfile);
        /*if(!$this->chakcacahefile($cachefile)){*/
            $content = file_get_contents($tplfile);
            $parsefile = $this->compiler($content,$cachefile,$needreplace);
        /*}else{
            $parsefile = $cachefile;
        }*/
        $GLOBAL['templateTime']=mtime();
        return $parsefile;
    }
    private function compiler($content,$cachefile, $replace){
        if($replace){
            $this->parse_include($content);//解析include
            $this->parse_template($content);//解析模板
        }
        //加入安全代码和模版记录
        $content = "<? if(!defined('IN_SYSTEM')) exit('Access Denied'); /*".serialize($this->includeTemplate)."*/?>\n".$content."\n".'<? $endTime = mtime()?>';
        $Log = New Log();
        $Log->runlog("TemplateNewCreate",serialize($this->includeTemplate),false);
        $this->includeTemplate = array();
        if (!@$fp = fopen($cachefile, 'w')) {
            $this -> error('directory_notfound', dirname($cachefile));
        }
        flock($fp, 2);
        fwrite($fp, $content);
        fclose($fp);
        return $cachefile;
    }
    private function chakcacahefile($cachefile){
        //判断是否存在编译文件
        if(!is_file($cachefile)){
            return false;
        }
        //读取编译文件失败
        if(!$handle = @fopen($cachefile,"r")){
            return false;
        }
       //读取编译文件第一行
        preg_match('/\/\*(.+?)\*\//', fgets($handle), $matches);
        if (!isset($matches[1])) {
            return false;
        }
        $includeFile = unserialize($matches[1]);
        if (!is_array($includeFile)) {
            return false;
        }
        // 检查模板文件是否有更新
        foreach ($includeFile as $path => $time) {
            if (strstr($path,BASIC_PATH) && is_file($path) && filemtime($path) > $time) {
                // 模板文件如果有更新则缓存需要更新
                return false;
            }
        }
        return true;
    }
    //解析template包含的模板
    private function parse_include(&$content){ 
         $tplreg = "/[\n\r\t]*(\<\!\-\-)?\{template\s+(.+?)\}(\-\-\>)?[\n\r\t]*/is";
         if (preg_match_all($tplreg, $content, $matches)) {
                foreach($matches[2] as $k=>$match) {
                    // 分析模板文件名并读取内容
                    $parestr = $this->parse_template_include($match);
                    $content = str_replace($matches[0][$k], $parestr, $content);
                    // 再次对包含文件进行模板分析
                    $this->parse_include($content);
                }
                unset($matches);
            }
    }
    //解析模板路径
    private function parse_tplfile($tplfile, $tpldir = ''){

            $tmp = TEMPLATE.$tpldir."/".$tplfile;
            //$tmp = str_replace("_/","/",$tmp);
            //$tmp = str_replace("_","/",$tmp);

        if (is_file($tmp)) {
            $tplfile = $tmp;
        } else {
            $tpl = /*TEMPLATE.$tpldir."/".$tplfile*/$tmp;
            $this->error('template_notfound', $tpl);
        }
        return $tplfile;
    }
    //读取模板内容
    private function parse_template_include($tpl){
        $template = $this->parse_tplfile($tpl);
        $this->includeTemplate[$template] = filemtime($template);
        if(!$fp = fopen($template, 'r')){
            return;
        }
        $content = fread($fp, filesize($template));
        return $content;
    }

    function parse_template(&$template) {
        $var_regexp = "((\\\$[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*(\-\>)?[a-zA-Z0-9_\x7f-\xff]*)(\[[a-zA-Z0-9_\-\.\"\'\[\]\$\x7f-\xff]+\])*)";
        $const_regexp = "([A-Z_\x7f-\xff][A-Z0-9_\x7f-\xff]*)";

        $template = str_replace(array('{echo STATIC_PATH}','{echo ROJ_VERSION}'),array(STATIC_PATH,ROJ_VERSION),$template);

        $template = preg_replace("/([\n\r]+)\t+/s", "\\1", $template);
        $template = preg_replace("/\<\!\-\-\{(.+?)\}\-\-\>/s", "{\\1}", $template);
//        js的lang替换
        $template = preg_replace_callback("/<script[^>]+?src=\"(.+?)\".*?>[\s\S]*?/i", array($this, 'parse_template_callback_javascript'), $template);
//           模版lang替换
        $template = preg_replace_callback("/\{LNG\s+(.+?)\}/is", array($this, 'parse_template_callback_languagevar'), $template);
        $template = preg_replace_callback("/[\n\r\t]*\{eval\}\s*(\<\!\-\-)*(.+?)(\-\-\>)*\s*\{\/eval\}[\n\r\t]*/is", array($this, 'parse_template_callback_evaltags_2'), $template);
        $template = preg_replace_callback("/[\n\r\t]*\{eval\s+(.+?)\s*\}[\n\r\t]*/is", array($this, 'parse_template_callback_evaltags_1'), $template);
        $template = str_replace("{LF}", "<?=\"\\n\"?>", $template);
        $template = preg_replace("/\{(\\\$[a-zA-Z0-9_\-\>\[\]\'\"\$\.\x7f-\xff]+)\}/s", "<?=\\1?>", $template);
//        $template = preg_replace_callback("/\{hook\/(\w+?)(\s+(.+?))?\}/i", array($this, 'parse_template_callback_hooktags_13'), $template);
        $template = preg_replace_callback("/$var_regexp/s", array($this, 'parse_template_callback_addquote_1'), $template);
        $template = preg_replace_callback("/\<\?\=\<\?\=$var_regexp\?\>\?\>/s", array($this, 'parse_template_callback_addquote_1'), $template);

        $template = preg_replace_callback("/[\n\r\t]*\{echo\s+(.+?)\}[\n\r\t]*/is", array($this, 'parse_template_callback_stripvtags_echo1'), $template);

        $template = preg_replace_callback("/([\n\r\t]*)\{if\s+(.+?)\}([\n\r\t]*)/is", array($this, 'parse_template_callback_stripvtags_if123'), $template);
        $template = preg_replace_callback("/([\n\r\t]*)\{elseif\s+(.+?)\}([\n\r\t]*)/is", array($this, 'parse_template_callback_stripvtags_elseif123'), $template);
        $template = preg_replace("/\{else\}/i", "<? } else { ?>", $template);
        $template = preg_replace("/\{\/if\}/i", "<? } ?>", $template);

        $template = preg_replace_callback("/[\n\r\t]*\{loop\s+(\S+)\s+(\S+)\}[\n\r\t]*/is", array($this, 'parse_template_callback_stripvtags_loop12'), $template);
        $template = preg_replace_callback("/[\n\r\t]*\{loop\s+(\S+)\s+(\S+)\s+(\S+)\}[\n\r\t]*/is", array($this, 'parse_template_callback_stripvtags_loop123'), $template);
        $template = preg_replace("/\{\/loop\}/i", "<? } ?>", $template);

        $template = preg_replace("/\{$const_regexp\}/s", "<?=\\1?>", $template);
        if (!empty($this -> replacecode)) {
            $template = str_replace($this -> replacecode['search'], $this -> replacecode['replace'], $template);
        }
        $template = preg_replace("/ \?\>[\n\r]*\<\? /s", " ", $template);

        $template = preg_replace_callback("/\"(http)?[\w\.\/:]+\?[^\"]+?&[^\"]+?\"/", array($this, 'parse_template_callback_transamp_0'), $template);
        $template = preg_replace_callback("/\<script[^\>]*?src=\"(.+?)\"(.*?)\>\s*\<\/script\>/is", array($this, 'parse_template_callback_stripscriptamp_12'), $template);
        $template = preg_replace_callback("/[\n\r\t]*\{block\s+([a-zA-Z0-9_\[\]]+)\}(.+?)\{\/block\}/is", array($this, 'parse_template_callback_stripblock_12'), $template);
        $template = preg_replace("/\<\?(\s{1})/is", "<?php\\1", $template);
        $template = preg_replace("/\<\?\=(.+?)\?\>/is", "<?php echo \\1;?>", $template);
        
    }

    function parse_template_callback_javascript($matches) {
        return $this -> loadjstemplate($matches[1]);
    }

    function replace_js_language_var($arr) {

        return $this->return_js_varvalue($arr[1]);

    }

    function parse_template_callback_languagevar($matches) {
        return $this -> languagevar($matches[1]);
    }
    function parse_template_callback_blocktags_1($matches) {
        return $this -> blocktags($matches[1]);
    }

    function parse_template_callback_blockdatatags_1($matches) {
        return $this -> blockdatatags($matches[1]);
    }

    function parse_template_callback_datetags_1($matches) {
        return $this -> datetags($matches[1]);
    }

    function parse_template_callback_evaltags_2($matches) {
        return $this -> evaltags($matches[2]);
    }

    function parse_template_callback_evaltags_1($matches) {
        return $this -> evaltags($matches[1]);
    }


    function parse_template_callback_hooktags_13($matches) {
        return $this -> hooktags($matches[1], $matches[3]);
    }

    function parse_template_callback_addquote_1($matches) {
        return $this -> addquote('<?=' . $matches[1] . '?>');
    }

    function parse_template_callback_stripvtags_template1($matches) {
        return $this -> stripvtags('<? include template(\'' . $matches[1] . '\'); ?>');
    }

    function parse_template_callback_stripvtags_echo1($matches) {
        return $this -> stripvtags('<? echo ' . $matches[1] . '; ?>');
    }

    function parse_template_callback_stripvtags_if123($matches) {
        return $this -> stripvtags($matches[1] . '<? if(' . $matches[2] . ') { ?>' . $matches[3]);
    }

    function parse_template_callback_stripvtags_elseif123($matches) {
        return $this -> stripvtags($matches[1] . '<? } elseif(' . $matches[2] . ') { ?>' . $matches[3]);
    }

    function parse_template_callback_stripvtags_loop12($matches) {
        return $this -> stripvtags('<? if(is_array(' . $matches[1] . ')) foreach(' . $matches[1] . ' as ' . $matches[2] . ') { ?>');
    }

    function parse_template_callback_stripvtags_loop123($matches) {
        return $this -> stripvtags('<? if(is_array(' . $matches[1] . ')) foreach(' . $matches[1] . ' as ' . $matches[2] . ' => ' . $matches[3] . ') { ?>');
    }

    function parse_template_callback_transamp_0($matches) {
        return $this -> transamp($matches[0]);
    }

    function parse_template_callback_stripscriptamp_12($matches) {
        return $this -> stripscriptamp($matches[1], $matches[2]);
    }

    function parse_template_callback_stripblock_12($matches) {
        return $this -> stripblock($matches[1], $matches[2]);
    }


    function return_js_varvalue($var,$jslang = false) {    
        $langvar = LNG();
        if (!isset($langvar[$var])) {
             return "'".$var."'";
        }
        $jsonencode = json_encode($langvar[$var]);
         return $jsonencode;
    }

    function loadjstemplate($parameter) {
        $paramet = trim($parameter,"\0");
        $parameter = str_replace(array('{echo STATIC_PATH}','{echo ROJ_VERSION}','?ver='),'',$paramet);

        $src = BASIC_PATH."static/" . $parameter;
        $src = preg_replace('/\?.*/i', '', $src);

        $xdtemp = APP_HOST.str_replace(BASIC_PATH,'',TEMP_PATH);

        $jsname = str_replace('.','_',basename($src,'.js'));

        if(get_path_ext($src) == "js"){
            $content = file_get_contents($src);

            $jscachefilea = $jsname. '_tmp.js';
            $jscachefile = TEMP_DIR.$jscachefilea;

            if(!file_exists($jscachefile)){
                if (!@$fp = fopen($jscachefile, 'w+')) {
                    $this -> error('directory_notfound', TEMP_DIR);
                }
                fwrite($fp, $content);
                fclose($fp);
            }else{
                return '<script type="text/javascript" src="'.$xdtemp.$jscachefilea.'"></script>';            
            }
        }
        return '<script type="text/javascript" src="'.$paramet.'">';            
    }
//    模版lang替换
    function languagevar($var) {
            return LNG("$var");
    }

    function evaltags($php) {
        //$php = str_replace('\"', '"', $php);//对原本的tpl支持不好
        $i = count($this -> replacecode['search']);
        $this -> replacecode['search'][$i] = $search = "<!--EVAL_TAG_$i-->";
        $this -> replacecode['replace'][$i] = "<? $php?>";
        return $search;
    }

    function hooktags($hookid, $key = '') {
        global $config;
 /*       $i = count($this -> replacecode['search']);
        $this -> replacecode['search'][$i] = $search = "<!--HOOK_TAG_$i-->";
        $dev = '';
        if (isset($_G['config']['plugindeveloper']) && $_G['config']['plugindeveloper'] == 2) {
            $dev = "echo '<hook>[" . ($key ? 'array' : 'string') . " $hookid" . ($key ? '/\'.' . $key . '.\'' : '') . "]</hook>';";
        }
        $key = $key != '' ? "[$key]" : '';
        $this -> replacecode['replace'][$i] = "<?php {$dev}if(!empty(\$_G['setting']['pluginhooks']['$hookid']$key)) echo \$_G['setting']['pluginhooks']['$hookid']$key;?>";
        return $search;*/ //HOOK已在代码中实现
    }

    function stripphpcode($type, $code) {
        $this -> phpcode[$type][] = $code;
        return '{phpcode:' . $type . '/' . (count($this -> phpcode[$type]) - 1) . '}';
    }


    function getphptemplate($content) {
        $pos = strpos($content, "\n");
        return $pos !== false ? substr($content, $pos + 1) : $content;
    }

    

    function transamp($str) {
        $str = str_replace('&', '&amp;', $str);
        $str = str_replace('&amp;amp;', '&amp;', $str);
        $str = str_replace('\"', '"', $str);
        return $str;
    }

    function addquote($var) {
        return str_replace("\\\"", "\"", preg_replace("/\[([a-zA-Z0-9_\-\.\x7f-\xff]+)\]/s", "['\\1']", $var));
    }

    function stripvtags($expr, $statement = '') {
        $expr = str_replace('\\\"', '\"', preg_replace("/\<\?\=(\\\$.+?)\?\>/s", "\\1", $expr));
        $statement = str_replace('\\\"', '\"', $statement);
        return $expr . $statement;
    }

    function stripscriptamp($s, $extra) {
        $extra = str_replace('\\"', '"', $extra);
        $s = str_replace('&amp;', '&', $s);
        return "<script src=\"$s\" type=\"text/javascript\"$extra></script>";
    }

    function stripblock($var, $s) {
        $s = str_replace('\\"', '"', $s);
        $s = preg_replace("/<\?=\\\$(.+?)\?>/", "{\$\\1}", $s);
        preg_match_all("/<\?=(.+?)\?>/", $s, $constary);
        $constadd = '';
        $constary[1] = array_unique($constary[1]);
        foreach ($constary[1] as $const) {
            $constadd .= '$__' . $const . ' = ' . $const . ';';
        }
        $s = preg_replace("/<\?=(.+?)\?>/", "{\$__\\1}", $s);
        $s = str_replace('?>', "\n\$$var .= <<<EOF\n", $s);
        $s = str_replace('<?', "\nEOF;\n", $s);
        $s = str_replace("\nphp ", "\n", $s);
        return "<?\n$constadd\$$var = <<<EOF\n" . $s . "\nEOF;\n?>";
    }

    function error($message, $tplname) {
        $Err = New S_Error();
        $Err->template_error($message, $tplname);
    }
}
?>