<?php
IF(!DEFINED('IN_SYSTEM')) DIE("Access Denied");
/*
* @product RojExplorer
* @author Luojie
* @copyright rojcms team 2017.
*/
$trace_errors = array();
$trace_debug = array();
/**
 * 系统错误类
 */
	class S_Error
	{
		public static function system_error($message, $show = true, $save = true, $halt = true, $showtrace = '') {
		global $wap;
		if(defined('INITED') && function_exists('LNG')){
			if(!empty($message)) {
				$message = LNG($message);
			} else {
				$message = LNG('error_unknow');
			}
		}

			list($showtrace, $logtrace) = self::debug_backtrace();

			if($save) {
				$messagesave = '<b>'.$message.'</b><br><b>PHP:</b>'.$logtrace;
				self::write_error_log($messagesave);
			}

			if($show) {
				if(!$wap) {
					self::show_error('System', "<li>$message</li>", $showtrace, 0);
				} else {
					self::mobile_show_error('System', "<li>$message</li>", $showtrace, 0);
				}
			}

			if($halt) {
				exit();
			} else {
				return $message;
			}
		}

		public static function template_error($message, $tplname) {
			$message = LNG($message);
			$tplname = str_replace(BASIC_PATH, '', $tplname);
			$message = $message.': '.$tplname;
			self::system_error($message);
		}

		public static function debug_backtrace() {
			$skipfunc[] = 'S_Error->debug_backtrace';
			$skipfunc[] = 'S_Error->template_error';
			$skipfunc[] = 'S_Error->system_error';
			$skipfunc[] = 'S_Error::debug_backtrace';
			$skipfunc[] = 'S_Error::system_error';
			$skipfunc[] = 'S_Error::template_error';

			$show = $log = '';
			$debug_backtrace = debug_backtrace();
			$called = false;
			krsort($debug_backtrace);
			foreach ($debug_backtrace as $k => $_error) {
				if($_error['function'] == "show_tips"){
					$show = "";
					break;
				}
				if($_error['function'] == "handleShutdown") break;
				if(!isset($_error['file'])) break;
				if(!isset($_error['line'])) break;
				if(isset($fulltrace)){
					$file = str_replace(str_replace('/','\\',BASIC_PATH), '.\\', $_error['file']);
				}else{
					$file = $_error['file'];
				}
				$func = isset($_error['class']) ? $_error['class'] : '';
				$func .= isset($_error['type']) ? $_error['type'] : '';
				$func .= isset($_error['function']) ? $_error['function'] : '';
				
				if(in_array($func, $skipfunc)) {
					break;
				}
				
				if($called){
					$val .= "\nfunc:".$func;
				}
				
				if(strstr($func,"call_user_func")) {
					$called = true;
				}
				
				$_error['line'] = sprintf('%04d', $_error['line']);

				$show .= "<li>[Line: $_error[line]]".$file."($func)</li>";
				$log .= !empty($log) ? ' -> ' : '';
				$log .= $file.':'.$_error['line'];
			}
			if($called && !empty($val)){
			exit($val);
			}
			return array($show, $log);
		}

		public static function exception_error($exception) {
			global $lang;
			$type = 'system';
			$errormsg = $exception->getMessage();
			if(!$lang) $lang = "zh_CN";
			if(strstr($lang,"zh")) $errormsg = errtochn($errormsg);

			$trace = $exception->getTrace();
			krsort($trace);

			$trace[] = array('file'=>$exception->getFile(), 'line'=>$exception->getLine(), 'function'=> 'break');
			$phpmsg = array();
			foreach ($trace as $error) {
				if(!empty($error['function'])) {
					$fun = '';
					if(!empty($error['class'])) {
						$fun .= $error['class'].$error['type'];
					}
					$fun .= $error['function'].'(';
					if(!empty($error['args'])) {
						$mark = '';
						foreach($error['args'] as $arg) {
							$fun .= $mark;
							if(is_array($arg)) {
								$fun .= 'Array';
							} elseif(is_bool($arg)) {
								$fun .= $arg ? 'true' : 'false';
							} elseif(is_int($arg)) {
								$fun .= (defined('GLOBAL_DEBUG') && GLOBAL_DEBUG) ? $arg : '%d';
							} elseif(is_float($arg)) {
								$fun .= (defined('GLOBAL_DEBUG') && GLOBAL_DEBUG) ? $arg : '%f';
							} else {
								$fun .= (defined('GLOBAL_DEBUG') && GLOBAL_DEBUG) ? '\''.htmlspecial_decode(substr(self::clear($arg), 0, 10)).(strlen($arg) > 10 ? ' ...' : '').'\'' : '%s';
							}
							$mark = ', ';
						}
					}

					$fun .= ')';
					$error['function'] = $fun;
				}
				$phpmsg[] = array(
						'file' => str_replace(array(BASIC_PATH, '\\'), array('', '/'), $error['file']),
						'line' => $error['line'],
						'function' => $error['function'],
				);
			}

			self::show_error($type, $errormsg, $phpmsg);
			exit();

		}

		public static function show_error($type, $errormsg, $phpmsg = '') {

			ob_end_clean();
			$gzip = false;//TODO
			
			ob_start($gzip ? 'ob_gzhandler' : null);

			$host = $_SERVER['HTTP_HOST'];
			$title = 'System';
			echo <<<EOT
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html>
	<head>
		<title>$host - $title Error</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta name="ROBOTS" content="NOINDEX,NOFOLLOW,NOARCHIVE" />
		<style type="text/css">
		<!--
		body { background-color: white; color: black; font: 9pt/11pt verdana, arial, sans-serif;}
		#container { width: 1024px; }
		#message   { width: 1024px; color: black; }

		.red  {color: red;}
		a:link     { font: 9pt/11pt verdana, arial, sans-serif; color: red; }
		a:visited  { font: 9pt/11pt verdana, arial, sans-serif; color: #4e4e4e; }
		h1 { color: #FF0000; font: 18pt "Verdana"; margin-bottom: 0.5em;}
		.bg1{ background-color: #FFFFCC;}
		.bg2{ background-color: #EEEEEE;}
		.table {background: #AAAAAA; font: 11pt Menlo,Consolas,"Lucida Console"}
		.info {
				background: none repeat scroll 0 0 #F3F3F3;
				border: 0px solid #aaaaaa;
				border-radius: 10px 10px 10px 10px;
				color: #000000;
				font-size: 11pt;
				line-height: 160%;
				margin-bottom: 1em;
				padding: 1em;
		}

		.help {
				background: #F3F3F3;
				border-radius: 10px 10px 10px 10px;
				font: 12px verdana, arial, sans-serif;
				text-align: center;
				line-height: 160%;
				padding: 1em;
		}

		-->
		</style>
	</head>
	<body>
	<div id="container">
	<h1>RojeXplorer! $title Error</h1>
	<div class='info'>$errormsg</div>


EOT;
			if(!empty($phpmsg)) {
				echo '<div class="info">';
				echo '<p><strong>PHP Debug</strong></p>';
				echo '<table cellpadding="5" cellspacing="1" width="100%" class="table">';
				if(is_array($phpmsg)) {
					echo '<tr class="bg2"><td>No.</td><td>File</td><td>Line</td><td>Code</td></tr>';
					foreach($phpmsg as $k => $msg) {
						$k++;
						echo '<tr class="bg1">';
						echo '<td>'.$k.'</td>';
						echo '<td>'.$msg['file'].'</td>';
						echo '<td>'.$msg['line'].'</td>';
						echo '<td>'.$msg['function'].'</td>';
						echo '</tr>';
					}
				} else {
					echo '<tr><td><ul>'.$phpmsg.'</ul></td></tr>';
				}
				echo '</table></div>';
			}else{
			
			}

			$endmsg = defined('INITED') && function_exists('LNG')?LNG('error_end_message', array('host'=>$host)):"错误";
			echo <<<EOT
	<div class="help">$endmsg</div>
	</div>
	</body>
	</html>
EOT;
			exit();

		}

		public static function mobile_show_error($type, $errormsg, $phpmsg) {

			ob_end_clean();
			ob_start();

			$host = $_SERVER['HTTP_HOST'];
			$phpmsg = trim($phpmsg);
			$title = 'Mobile System';
			echo <<<EOT
	<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN" "http://www.wapforum.org/DTD/xhtml-mobile10.dtd">
	<html>
	<head>
		<title>$host - $title Error</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta name="ROBOTS" content="NOINDEX,NOFOLLOW,NOARCHIVE" />
		<style type="text/css">
		<!--
		body { background-color: white; color: black; }
		UL, LI { margin: 0; padding: 2px; list-style: none; }
		#message   { color: black; background-color: #FFFFCC; }
		#bodytitle { font: 11pt/13pt verdana, arial, sans-serif; height: 20px; vertical-align: top; }
		.bodytext  { font: 8pt/11pt verdana, arial, sans-serif; }
		.help  { font: 12px verdana, arial, sans-serif; color: red;}
		.red  {color: red;}
		a:link     { font: 8pt/11pt verdana, arial, sans-serif; color: red; }
		a:visited  { font: 8pt/11pt verdana, arial, sans-serif; color: #4e4e4e; }
		-->
		</style>
	</head>
	<body>
	<table cellpadding="1" cellspacing="1" id="container">
	<tr>
		<td id="bodytitle" width="100%">RojeXplorer! $title Error </td>
	</tr>
EOT;

			echo <<<EOT
	<tr><td><hr size="1"/></td></tr>
	<tr><td class="bodytext">Error messages: </td></tr>
	<tr>
		<td class="bodytext" id="message">
			<ul> $errormsg</ul>
		</td>
	</tr>
EOT;
			$endmsg = LNG('mobile_error_end_message', array('host'=>$host));
			echo <<<EOT
	<tr>
		<td class="help"><br />$endmsg</td>
	</tr>
	</table>
	</body>
	</html>
EOT;
			exit();
		}

		public static function clear($message) {
			return str_replace(array("\t", "\r", "\n"), " ", $message);
		}

		public static function write_error_log($message) {

			$message = self::clear($message);
			$time = time();
			is_dir(LOG_DIR)?null:$is = true;
			if(isset($is)) return false;

			$hash = md5($message."S_Err");

			$uri = 'Request: '.htmlspecial_decode(self::clear($_SERVER['REQUEST_URI']));
			$message = "<?PHP exit;?>\tTime:{$time}\tMSG:$message\tHASH:$hash\tURI:$uri\n";

			$log = New Log();
			$log -> runlog('ErrorLog',$message);
		}
	}

	function handleException($exception) {
		global $MyError,$blockerr;
			$MyError->exception_error($exception);
	}


	function handleError($errno, $errstr, $errfile, $errline) {
		global $config,$MyError,$blockerr,$changerr;
		$lang = isset($config['lang'])?$config['lang']:"zh";
		if($errno && GLOBAL_DEBUG) {
			$err = true;
			for($i = 0;$i < count($blockerr);$i++){
				if(strstr($errstr,$blockerr[$i])) $err = false;
				if(!$err) break;
			}
			foreach($changerr as $key => $val){
				if(strstr($errstr,$key)) $errstr = $val.':'.$errstr;break;
			}
			$stop = true;
			switch($errno){
				case E_NOTICE:
				case E_WARNING:
				$stop = false;
			}
			if($err && $stop){
				strstr($lang,"zh")?$errstr = errtochn($errstr):null;
				$MyError->system_error($errstr, true, true, true);
			}else{
				$trace_errors[] = "[$errno] $errstr on $errfile at line $errline";
			}
		}
	}
	//title message info
	function handleShutdown() {
		global $config,$MyError;
		$lang = isset($config['lang'])?$config['lang']:"zh";
		$errorlast = error_get_last();
		if(isset($errorlast['type']) && defined("INITED")) {
			$stop = true;
			switch($errorlast['type']){
				case E_NOTICE:
					$errortypeEN = "Notice";
					$errortypeCN = "提示";
					$stop = false;
				break;
				case E_WARNING:
					$errortypeEN = "Warning";
					$errortypeCN = "警告";
						$stop = false;
				break;
				case 1:
					$errortypeEN = "Fatal Error";
					$errortypeCN = "致命错误";
				break;
				case E_PARSE:
					$errortypeEN = "Parse Error";
					$errortypeCN = "解释时错误";
				break;
				case E_COMPILE_ERROR:
					$errortypeEN = "Compile Error";
					$errortypeCN = "编译时错误";
				break;
				case E_CORE_ERROR:
					$errortypeEN = "Core Error";
					$errortypeCN = "核心错误";
				break;
				case E_STRICT:
					$errortypeEN = "Strict Error";
					$errortypeCN = "严重错误";
				case 8192:
					return;
				break;
				default:
					$errortypeEN = "Unknown Error ID:".$errorlast['type'];
					$errortypeCN = "未知错误ID:".$errorlast['type'];
			}
			if($stop || ERROR_SHOWALL){
				if(strstr($lang,"zh")){
					$errmsg = errtochn($errorlast['message']);
					$MyError->system_error("检测到 <font color='red'>".$errortypeCN."</font>: ".$errmsg." 在 ".$errorlast['file']." 的第 ".$errorlast['line']." 行", true, true, false);
				}else{
					$MyError->system_error("Catched a <font color='red'>".$errortypeEN."</font>: ".$errorlast['message']." on ".$errorlast['file']." at line ".$errorlast['line'], true, true, false);
				}
			}else{
				if(strstr($lang,"zh")){
					$errmsg = errtochn($errorlast['message']);
					$trace_errors[] = "检测到 <font color='red'>".$errortypeCN."</font>: ".$errmsg." 在 ".$errorlast['file']." 的第 ".$errorlast['line']." 行";
				}else{
					$trace_errors[] = "Catched a <font color='red'>".$errortypeEN."</font>: ".$errorlast['message']." on ".$errorlast['file']." at line ".$errorlast['line'];
				}
			}
		}
	}