define(function(require, exports){
var ThemeList = {
    ting: {
        path: "music/ting",
        width: 410,
        height: 530
    },
    beveled: {
        path: "music/beveled",
        width: 350,
        height: 200
    },
    kuwo: {
        path: "music/kuwo",
        width: 480,
        height: 200
    },
    manila: {
        path: "music/manila",
        width: 320,
        height: 400
    },
    mp3player: {
        path: "music/mp3player",
        width: 320,
        height: 410
    },
    qqmusic: {
        path: "music/qqmusic",
        width: 300,
        height: 400
    },
    somusic: {
        path: "music/somusic",
        width: 420,
        height: 137
    },
    xdj: {
        path: "music/xdj",
        width: 595,
        height: 235
    },
    webplayer: {
        path: "movie/webplayer",
        width: 600,
        height: 400
    },
    qqplayer: {
        path: "movie/qqplayer",
        width: 600,
        height: 400
    },
    tvlive: {
        path: "movie/tvlive",
        width: 600,
        height: 400
    },
    youtube: {
        path: "movie/youtube",
        width: 600,
        height: 400
    },
    vplayer: {
        path: "movie/vplayer",
        width: 600,
        height: 400
    }
},

 getType = function(ext) {
        var musicarr = 'mp3,wav,aac,m4a,oga,ogg,webma';
        return "music" == ext ? "music_player" : (void 0 == ext && (ext = "mp3"), musicarr.indexOf(ext) ? "movie_player" : "music_player")
    },

 CreateCMP = function(type, cmpurl) {
        var theme, title, resizeable, icon;
        if("music_player" == type){
            icon = core.icon("mp3"),
            theme = ThemeList[window.top.CMP.ThemeMusic],
            title = "音乐播放器",
            resizeable = false;
        }else{
            icon = core.icon("flv"),
            theme = ThemeList[window.top.CMP.ThemeMovie],
            title = "视频播放器",
            resizeable = true;
        };
        var CMP = core.createFlash(cmpurl + "cmp.swf", "context_menu=2&auto_play=1&play_mode=1&skin=skins/" + theme.path + ".zip", type),
            dialogConfig = {
                id: type + "_dialog",
                simple: true,
                ico: icon,
                title: title,
                width: theme.width + 10,
                height: theme.height,
                content: '<div class="wmp_player"></div><div class="flash_player">' + CMP + "</div>",
                resize: resizeable,
                padding: 0,
                fixed: true,
                close: function() {
                    var CMP = getCMP(type);
                    if(CMP && CMP.sendEvent) CMP.sendEvent("view_stop");
                }
            };
        window.top.CMP ? art.dialog.through(dialogConfig) : $.dialog(dialogConfig)
    },

 MakeList = function(url) {
        var source,
            name,
            text = "";
        if(url.search("fileProxy") == -1){
            source = urlEncode(url), name = core.pathThis(url);
        }else{
            source = url, name = core.pathThis(urlDecode(source));
        }
        source = source.replace(/%2F/g, "/");
        source = source.replace(/%3F/g, "?");
        source = source.replace(/%26/g, "&");
        source = source.replace(/%3A/g, ":");
        source = source.replace(/%3D/g, "=");
        text += '<list><m type="" src="' + source + '" label="' + name + '"/></list>';
        return text;
    },

 getCMP = function(CMPId) {
        return window.top.CMP ? window.top.CMP.get(CMPId) : CMP.get(CMPId)
    },

 CMPPlay = function(File, CMPId) {
        var CMP = getCMP(CMPId),
            List = MakeList(File);
        try {
            CMP.config("play_mode", "normal");
            var LastSong = CMP.list().length;
            CMP.list_xml(List, true);
            CMP.sendEvent("view_play", LastSong + 1);
        } catch (e) {}
    },

 addEventListener = function(type) {
        if (type != "music_player") {
            var CMP = getCMP(getType("movie"));
            if(CMP){
                CMP.addEventListener("control_load", "new_play");
                CMP.addEventListener("control_play", "new_play");
            }
        }
    };

return {
    changeTheme: function(type, theme) {
        var CMPType, CMP;
        if(type == "music"){
            CMPType = "music_player",
            window.top.CMP.ThemeMusic = theme;
        }else{
            CMPType = "movie_player",
            window.top.CMP.ThemeMovie = theme;
        }
        CMP = getCMP(CMPType);
        if(CMP){
            themeArr = ThemeList[theme];
            window.top.art.dialog.list[CMPType + "_dialog"].size(themeArr.width, themeArr.height);
            CMP.sendEvent("skin_load", "skins/" + themeArr.path + ".zip");
        }
    },
    play: function(url, ext, CMPpath) {
        var type = getType(ext),
            Created = getCMP(type);
        if (Created){
            CMPPlay(url, type);
            addEventListener(type);
            window.top.art.dialog.list[type + "_dialog"].display(true);
        } else {
            CreateCMP(type, CMPpath);
            var Interval = setInterval(function() {
                if(getCMP(type)){
                     CMPPlay(url, type);
                     addEventListener(type);
                     new_play(type);
                     clearInterval(Interval);
                     Interval = false;
                }
            }, 1e3);
            
        }
    }
}
});

var new_play = function(e) {
    if (e == "music_player") {
        $(".music_player_dialog .wmp_player").html("").css({
            width: "0px",
            height: "0px"
        });
        $(".music_player_dialog .flash_player").css({
            width: "100%",
            height: "100%"
        });
        return true;
    }
    var CMP;
    CMP = window.top.CMP ? window.top.CMP.get("movie_player") : CMP.get("movie_player");
    var UseWMP = function(url) {
        var html = '<object id="the_wmp_player" ',
            ua = navigator.userAgent;
        if(ua.indexOf("MSIE") != -1){
            html += 'classid="clsid:6BF52A52-394A-11d3-B153-00C04F79FAA6" ';
        }else if(ua.indexOf("Firefox") != -1 || ua.indexOf("Chrome") != -1 || ua.indexOf("Opera") != -1 || ua.indexOf("Safari") != -1) {
            html += 'type="application/x-ms-wmp" ';
        };
        html += 'width="100%" height="100%">';
        html += '<param name="URL" value="' + url + '">';
        html += '<param name="autoStart" value="true">';
        html += '<param name="autoSize" value="true">';
        html += '<param name="invokeURLs" value="false">';
        html += '<param name="playCount" value="100">';
        html += '<param name="Volume" value="100">';
        html += '<param name="defaultFrame" value="datawindow">';
        html += "</object>";
    };
    try {
        var CMPSrc = CMP.item("src").toLowerCase();
        if (CMPSrc.indexOf("wmv") > 1 || CMPSrc.indexOf("mpg") > 1 || CMPSrc.indexOf("avi") > 1 || CMPSrc.indexOf("wvx") > 1 || CMPSrc.indexOf("3gp") > 1) {
            $("div[id^='DIV_CMP_']").remove();
            var NewCMP = CreateCMP(CMPSrc);
            $(".movie_player_dialog .wmp_player").html(""), $(".movie_player_dialog .flash_player").css({
                width: "0px",
                height: "0px"
            });
            setTimeout(function() {
                $(".movie_player_dialog .wmp_player").html(NewCMP).css({
                    width: "100%",
                    height: "100%"
                })
            }, 300);
        } else {
            $(".movie_player_dialog .wmp_player").html("").css({
                width: "0px",
                height: "0px"
            });
            setTimeout(function() {
                $(".movie_player_dialog .flash_player").css({
                    width: "100%",
                    height: "100%"
                })
            }, 200);
        }
    } catch (e) {}
};


(function(window) {
    if (typeof (window.CMP) === "undefined") {
        window.CMP = (function() {
            var msie = /msie/.test(navigator.userAgent.toLowerCase()), merge = function(_o, o) {
                if (o && typeof (o) === "object") {
                    for ( var k in o) {
                        _o[k] = o[k];
                    }
                }
                return _o;
            }, make = function(id, width, height, url, flashvars, params, attrs) {
                attrs = merge({
                    width : width,
                    height : height,
                    id : id
                }, attrs);
                params = merge({
                    allowfullscreen : "true",
                    allowscriptaccess : "always"
                }, params);
                var vars, htm, arr = [];
                if (flashvars) {
                    vars = flashvars;
                    if (typeof (flashvars) === "object") {
                        for ( var k in flashvars) {
                            arr.push(k + "=" + encodeURIComponent(flashvars[k]));
                        }
                        vars = arr.join("&");
                    }
                    params.flashvars = vars;
                }
                htm = '<object ';
                htm += msie ? 'classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" ' : 'type="application/x-shockwave-flash" data="' + url + '" ';
                for ( var k in attrs) {
                    htm += k + '="' + attrs[k] + '" ';
                }
                htm += msie ? '><param name="movie" value="' + url + '" />' : '>';
                for (k in params) {
                    htm += '<param name="' + k + '" value="' + params[k] + '" />';
                }
                htm += '</object>';
                return htm;
            }, getSWF = function(id) {
                var o = document.getElementById(id);
                if (!o || o.nodeName.toLowerCase() != "object") {
                    o = msie ? window[id] : document[id];
                }
                return o;
            }, removeInIE = function(obj) {
                if (obj) {
                    for ( var i in obj) {
                        if (typeof (obj[i]) === "function") {
                            obj[i] = null;
                        }
                    }
                    obj.parentNode.removeChild(obj);
                }
            }, removeSWF = function(id) {
                if (id) {
                    var obj = (typeof (id) === "string") ? getSWF(id) : id;
                    if (obj && obj.nodeName.toLowerCase() == "object") {
                        if (msie) {
                            obj.style.display = "none";
                            (function() {
                                if (obj.readyState == 4) {
                                    removeInIE(obj);
                                } else {
                                    setTimeout(arguments.callee, 15);
                                }
                            })();
                        } else {
                            obj.parentNode.removeChild(obj);
                        }
                        return true;
                    }
                }
                return false;
            };
            return {
                create : function() {
                    return make.apply(this, arguments);
                },
                write : function() {
                    var htm = make.apply(this, arguments);
                    document.write(htm);
                    return htm;
                },
                get : function(id) {
                    return getSWF(id);
                },
                remove : function(id) {
                    return removeSWF(id);
                }
            };
        })();
    }
    var deltaDispatcher = function(event) {
        event = event || window.event;
        var target = event.target || event.srcElement;
        if (target && typeof (target.cmp_version) == "function") {
            var maxPos = target.skin("list.tree", "maxVerticalScrollPosition");
            if (maxPos > 0) {
                target.focus();
                if (event.preventDefault) {
                    event.preventDefault();
                }
                return false;
            }
        }
    };
    if (window.addEventListener) {
        window.addEventListener("DOMMouseScroll", deltaDispatcher, false);
    }
    window.onmousewheel = document.onmousewheel = deltaDispatcher;
})(window);