<?php
/*
 * @product RojExplorer
 * @author Luojie
 * @copyright rojcms team 2017.
 */

/*
 * 可以把数据目录移到web目录之外，使程序更安全, 不用限制用户的扩展名权限;
 * 1. 需要先将data文件夹移到别的地方 例如将data文件夹拷贝到D:/
 * 2. 在config文件夹下新建define.php 新增一行 <?php define('DATA_PATH','D:/data/');
 */

/*
 * 语言相关函数 LNG PATH: DATA/I18N (You can add more languages in setting.php)
 * I18n/
 *     |-----Language name/
 *                       |-----main.php[+]return array('keyN'=>'valN');[-] // array形式表示的语言
 *                       |
 *                       |-----about.html,edit.html,help.html 关于,编辑器首页,帮助首页
 *
 * LNG("LNGKey1"); // 得到一个KEY表示的语言(若KEY不存在，则返回它本身)
 * LNGArrays(array("lngkey1","not a key (such as ':')","lngkey2")); // 用Array同时获得多个KEY表示的语言
 * LNGAuto(array('支持语言1','支持语言2'...'支持语言N'),'语言1返回的值','语言2返回的值'...'语言N返回的值')
 */
 //escape() unescape()

/*
 * 致二次开发者:
 *  请在所有引用文件内第一行加上: <?php if(!defined('IN_SYSTEM')){die("Access Denied!");}?>
*/
if(!defined('IN_SYSTEM')) define('IN_SYSTEM',true); // 基本变量 
define('GLOBAL_DEBUG',true); // 开发模式
define('ERROR_SHOWALL',true);
//define('SHOW_TRACES',false); // 显示TRACE    [WIP]
define('GLOBAL_MULIT_FILE_FUNCTION_MAXFILES',50000);//pathInfoMulti 限制运行时间：10000files
//define('DEBUG_STEP_BY_STEP',false); // TODO

date_default_timezone_set(@date_default_timezone_get());
//set_time_limit(1200);//20min pathInfoMulti,search,upload,download...

ini_set("max_execution_time",1200);
ini_set('memory_limit','256M');
ini_set('session.cache_expire',1800);

/*
 * DIR定义
 */

//header('HTTP/1.1 200 Ok');//兼容部分lightHttp服务器环境; php5.1以下会输出异常；暂屏蔽
header("Content-type: text/html; charset=utf-8");
define('BASIC_PATH',str_replace('\\','/',dirname(dirname(__FILE__))).'/');
define('LIB_DIR',       BASIC_PATH .'app/');     	//系统库目录
define('PLUGIN_DIR',    BASIC_PATH .'plugins/');	//插件目录
define('CONTROLLER_DIR',LIB_DIR .'controller/'); 	//控制器目录
define('MODEL_DIR',     LIB_DIR .'model/');  		//模型目录
define('TEMPLATE',      LIB_DIR .'template/');   	//模版文件路径
define('FUNCTION_DIR',	LIB_DIR .'function/');		//函数库目录
define('CLASS_DIR',		LIB_DIR .'roj/');			//工具类目录
define('CORER_DIR',		LIB_DIR .'core/');			//核心目录
define('SDK_DIR',		LIB_DIR .'sdks/');			//SDK目录
define('STATIC_JS','app');			//没用
define('STATIC_LESS','css');			//没用
define('DEFAULT_PERMISSIONS',0755);	//新建文件、解压文件默认权限，777 部分虚拟主机限制了777

include(BASIC_PATH.'system/version.php');
/*
 * 数据管理
 */
if(file_exists(BASIC_PATH.'config/define.php')){
	include(BASIC_PATH.'config/define.php');
}
if(!defined('DATA_PATH')){
	define('DATA_PATH',BASIC_PATH .'data/');       //用户数据目录
}

define('USER_PATH',     DATA_PATH .'User/');        //用户目录
define('GROUP_PATH',    DATA_PATH .'Group/');       //群组目录
define('USER_SYSTEM',   DATA_PATH .'system/');      //用户数据存储目录
define('TEMP_PATH',     DATA_PATH .'temp/');        //临时目录
define('LOG_PATH',      TEMP_PATH .'log/');         //日志
define('LANGUAGE_PATH', BASIC_PATH .'system/i18n/');        //多语言目录

define('LOG_DIR', LOG_PATH);
define('TEMP_DIR', TEMP_PATH);

define('DATA_THUMB',    TEMP_PATH .'thumb/');       //缩略图生成存放

define('SESSION_ID','ROJ_SESSION_ID_'.substr(md5(BASIC_PATH),0,5));
define('ROJ_SESSION',   DATA_PATH .'session/');     //session目录

//iFastnet的服务器有时会加上i=1标志。为防止影响功能，在此处去除
if(isset($_GET["i"])) {
	$x=$_SERVER["REQUEST_URI"];
	$x=str_replace("?i=".$_GET["i"],"",$x);
	$x=str_replace("&i=".$_GET["i"],"",$x);
	if($_GET["i"]=="") {
		$x=str_replace("?i","",$x);
		$x=str_replace("&i","",$x);
	}
	
	header("HTTP/1.1 307 iFastNetRedirect");
	header("Location:".$x);
	exit;
}

//when edit a file ;check charset and auto converto utf-8;
if (strtoupper(substr(PHP_OS, 0,3)) === 'WIN') {
	$config['systemOS']='windows';
	$config['systemCharset']='gbk';// EUC-JP/Shift-JIS/BIG5  //user set your server system charset
	if(version_compare(phpversion(), '7.1.0', '>=')){//7.1 has auto apply the charset
		$config['systemCharset']='utf-8';
	}
} else {
	$config['systemOS']='linux';
	$config['systemCharset']='utf-8';
}

include(FUNCTION_DIR.'common.function.php');

$strTime=mtime();

include(FUNCTION_DIR.'web.function.php');
include(FUNCTION_DIR.'myfunctions.function.php');
include(FUNCTION_DIR.'file.function.php');
include(FUNCTION_DIR.'helper.function.php');

/*
 * 错误处理
 */

	$MyError = New S_Error();
	$blockerr = array(
	"failed to open stream: HTTP request failed! HTTP/1.1 403 Forbidden",
	"Cannot modify header information",
	"Automatically populating \$HTTP_RAW_POST_DATA is deprecated and will be removed in a future version",
	"Illegal IFD size"
	);
	$changerr = array(
		'$errorstr' => '$val'
	);// $errorstr will be change to $val

	function errtochn($errstr){
			$errstr = str_replace("syntax error,","语法错误:",$errstr);
			$errstr = str_replace("unexpected","未预料的",$errstr);
			$errstr = str_replace("Call to undefined function","调用未定义的函数",$errstr);
			$errstr = str_replace("Undefined variable","未定义的变量",$errstr);
			$errstr = str_replace("Use of undefined constant","未定义的常量",$errstr);
			$errstr = str_replace("assumed","也许是",$errstr);
			$errstr = str_replace("expecting","期待",$errstr);
			$errstr = str_replace("Undefined index","未定义的数组索引",$errstr);
			$errstr = str_replace("controller not exists","控制器不存在",$errstr);
			$errstr = str_replace("Cannot modify header information - headers already sent by (output started at","无法再修改头信息 - 文档已经输出 (在",$errstr);
			$errstr = str_replace("open_basedir restriction in effect. File(","open_basedir 限制! 目标(",$errstr);
			$errstr = str_replace(" is not within the allowed path(s): "," 不在可访问目录内",$errstr);
			// code...
			return $errstr;
	}

ini_set("display_errors","on");//on off

if(function_exists("handleException")) set_exception_handler('handleException');
if(GLOBAL_DEBUG){
	error_reporting(E_ALL);
	if(function_exists("handleError")) set_error_handler('handleError');
	if(function_exists("handleShutdown")) register_shutdown_function('handleShutdown');
}else{
	error_reporting(E_ALL^E_NOTICE^E_WARNING);
}

$config['appStartTime'] = mtime();
$config['appCharset']	= 'utf-8';//该程序整体统一编码
$config['checkCharset'] = 'ASCII,UTF-8,GB2312,GBK,BIG5,UTF-16,UCS-2,'.
		'Unicode,EUC-KR,EUC-JP,SHIFT-JIS,EUCJP-WIN,SJIS-WIN,JIS,LATIN1';//文件打开自动检测编码
$config['checkCharsetDefault'] = '';//if set,not check;

// 部分反向代理导致获取不到url的问题优化
if(isset($_COOKIE['APP_HOST'])){
	define('HOST',$_COOKIE['HOST']);
	define('APP_HOST',$_COOKIE['APP_HOST']);
}
if(!defined('HOST')){
	define('HOST',get_host().'/');
}
if(!defined('WEB_ROOT')){
	define('WEB_ROOT',get_webroot(BASIC_PATH));
}
if(!defined('APP_HOST')){
	define('APP_HOST',HOST.str_replace(WEB_ROOT,'',strtolower(BASIC_PATH)));
} //程序根目录
define('PLUGIN_HOST',APP_HOST.str_replace(BASIC_PATH,'',PLUGIN_DIR));//插件目录


include(BASIC_PATH.'config/setting.php');
header("Server: ".$config['settings']['serverName']);
header("X-Powered-By: ".$config['settings']['poweredBy']);

include(CONTROLLER_DIR.'util.php');

/**
 * 初始化
 */

$GarbageCleaner = New GC();
$GarbageCleaner->Run();

function init_common(){
	$GLOBALS['in'] = parse_incoming();
	if(!is_dir(DATA_PATH)){
		show_tips("data 目录不存在或无权限访问!\n\n(检查 DATA_PATH);");
	}
	if(!is_dir(USER_SYSTEM) || !is_dir(LANGUAGE_PATH)){
	show_tips("data 目录无效!\n\n(检查 DATA_PATH);");
}
	//检查是否更新失效
	$content = file_get_contents(BASIC_PATH.'system/version.php');
	$result  = match1($content, "'ROJ_VERSION','(.*)'");
	if($result != ROJ_VERSION){
		show_tips("您服务器开启了php缓存,文件更新尚未生效;
			请关闭缓存，或稍后1分钟刷新页面再试！
			<a href='http://www.tuicool.com/articles/QVjeu2i' target='_blank'>了解详情</a>");
	}

	// session path create and check
	$errorTips = "[Error Code:1002] 目录权限错误！请设置程序目录及所有子目录为读写状态，
				linux 运行如下指令：
				<pre>su -c 'setenforce 0'\nchmod -R 777 ".BASIC_PATH.'</pre>';
	
	//检查目录权限
	if( !is_writable(ROJ_SESSION) || 
		!is_writable(ROJ_SESSION.'index.html') || 
		!is_writable(DATA_PATH.'system/apps.php') ||
		!is_writable(DATA_PATH)){
		show_tips($errorTips);
	}
	//检查session是否存在
	if( !file_exists(ROJ_SESSION) ||
		!file_exists(ROJ_SESSION.'index.html')){
		mk_dir(ROJ_SESSION);
		touch(ROJ_SESSION.'index.html');
		if(!file_exists(ROJ_SESSION.'index.html') ){
			show_tips($errorTips);
		}
	}

	
	//version check update 
	$file = LIB_DIR.'update.php';
	if(file_exists($file)){
		//覆盖安装文件删除不了重定向问题优化
		if(!is_writable($file) ){
			show_tips($errorTips);
		}

		//update;
		include($file);
		updateCheck($file);

		//clear 
		del_file($file);
		if(file_exists($file)){
			show_tips($errorTips);
		}
		user_logout();
	}
}

init_common();

function init_session()
{
	$notcheck = json_decode(file_get_contents(BASIC_PATH.'system/notcheck.json'),true);
	$stact = $_SERVER["QUERY_STRING"];
	$stact = substr($stact,0,strpos($stact,"&"));
	$stact = str_replace("/",".",$stact);
	if (isset($_GET['accessToken']) && !in_array($stact ,$notcheck)) {
		access_token_check($_GET['accessToken']);
	}
	else if (isset($_GET['access_token']) && !in_array($stact ,$notcheck)) {
		access_token_check($_GET['access_token']);
	}
	else {
		session_name(SESSION_ID);
	}
	$save_path = session_save_path();
	if (class_exists('SaeStorage') || defined('SAE_APPNAME') || defined('SESSION_PATH_DEFAULT')
		|| @ini_get('session.save_handler') != 'files' || isset($_SERVER['HTTP_APPNAME'])) {
	}
	else {
		chmod_path(ROJ_SESSION, 0777);
		@session_save_path(ROJ_SESSION);
	}
	session_start();
	$_SESSION['roj'] = 1;
	session_write_close();
	unset($_SESSION);
	if(!headers_sent()) session_start();
	if (!$_SESSION['roj']) {
		session_save_path($save_path);
		session_start();
		$_SESSION['roj'] = 1;
		session_write_close();
		unset($_SESSION);
		session_start();
	}
	if (!$_SESSION['roj']) {
		show_tips('服务器session写入失败! (session write error)<br/>'.'请检查php.ini相关配置,查看磁盘是否已满,或咨询服务商<br/><br/>'
			. 'session.save_path='.$save_path.'<br/>'.'session.save_handler='.ini_get('session.save_handler')
			. '<br/>');
	}
}

function init_space_size_hook()
{
	Hook::bind('uploadFileBefore', 'space_size_use_check');
	Hook::bind('uploadFileAfter', 'spaceSizeChange');
	Hook::bind('explorer.serverDownloadBefore', 'space_size_use_check');
	Hook::bind('explorer.unzipBefore', 'space_size_use_check');
	Hook::bind('explorer.zipBefore', 'space_size_use_check');
	Hook::bind('explorer.pathCopy', 'space_size_use_check');
	Hook::bind('explorer.mkfileBefore', 'space_size_use_check');
	Hook::bind('explorer.mkdirBefore', 'space_size_use_check');
	Hook::bind('explorer.pathMove', 'space_size_use_check');
	Hook::bind('explorer.mkfileAfter', 'spaceSizeChange');
	Hook::bind('explorer.pathCopyAfter', 'spaceSizeChange');
	Hook::bind('explorer.unzipAfter', 'spaceSizeChange');
	Hook::bind('explorer.serverDownloadAfter', 'spaceSizeChange');
	Hook::bind('explorer.pathMoveBefore', 'space_size_use_check');
	Hook::bind('explorer.pathMoveAfter', 'spaceSizeChange_move');
	Hook::bind('explorer.pathRemoveAfter', 'space_size_use_reset');
}

function init_config()
{
	init_setting();
	init_session();
	!DEFINED('CUSTOM')?init_space_size_hook():null;
}



function useless($a){
	//模板防止被盗所用空函数
}

//自动运行的函数

DEFINED('CUSTOM')?NULL:$config['autorun'] = array(
	array('controller'=>'user','function'=>'loginCheck'),
	array('controller'=>'user','function'=>'authCheck'),
	array('controller'=>'user','function'=>'bindHook'),
);

define('INITED',true);
$initTime=mtime();
